Attribute VB_Name = "Module1"
Public Declare Function FindFirstFile Lib "kernel32.dll" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindNextFile Lib "kernel32.dll" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindClose Lib "kernel32.dll" (ByVal hFindFile As Long) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * 260
    cAlternate As String * 14
End Type

Public Type TagReturn
    SongName As String
    Artist As String
    Album As String
    Year As String
    Comment As String
    GenreNum As Long
    GenreStr As String
End Type

Private Type TagInfo
    Tag As String * 3
    SongName As String * 30
    Artist As String * 30
    Album As String * 30
    Year As String * 4
    Comment As String * 30
    genre As String * 1
End Type

Public Function GetTagInfo(ByVal strFileName As String) As TagReturn
Dim CurrentTag As TagInfo
Dim temp As String
On Error Resume Next
Open strFileName For Binary As #9
With CurrentTag
    Get #9, FileLen(strFileName) - 127, .Tag
    If Not .Tag = "TAG" Then
        GetTagInfo.SongName = "No information available"
        GetTagInfo.Artist = "No information available"
        GetTagInfo.Album = "No information available"
        GetTagInfo.Year = "No information available"
        GetTagInfo.Comment = "No information available"
        GetTagInfo.GenreNum = 0
        GetTagInfo.GenreStr = "No information available"
        Close #9
        Exit Function
    End If
    Get #9, , .SongName
    Get #9, , .Artist
    Get #9, , .Album
    Get #9, , .Year
    Get #9, , .Comment
    Get #9, , .genre
    Close #9
    GetTagInfo.SongName = TrimExcess(.SongName)
    GetTagInfo.Artist = TrimExcess(.Artist)
    GetTagInfo.Album = TrimExcess(.Album)
    GetTagInfo.Year = TrimExcess(.Year)
    GetTagInfo.Comment = TrimExcess(.Comment)
    If .genre <> " " Then temp = RTrim(.genre) Else temp = " "
    temp = Asc(temp)
    GetTagInfo.GenreNum = temp
    Select Case temp
        Case 255
            GetTagInfo.GenreStr = ""
        Case 123
            GetTagInfo.GenreStr = "A Cappella"
        Case 34
            GetTagInfo.GenreStr = "Acid"
        Case 74
            GetTagInfo.GenreStr = "Acid Jazz"
        Case 73
            GetTagInfo.GenreStr = "Acid Punk"
        Case 99
            GetTagInfo.GenreStr = "Acoustic"
        Case 40
            GetTagInfo.GenreStr = "Alt. Rock"
        Case 20
            GetTagInfo.GenreStr = "Alternative"
        Case 26
            GetTagInfo.GenreStr = "Ambient"
        Case 90
            GetTagInfo.GenreStr = "Avantgarde"
        Case 116
            GetTagInfo.GenreStr = "Ballad"
        Case 41
            GetTagInfo.GenreStr = "Bass"
        Case 135
            GetTagInfo.GenreStr = "Beat"
        Case 85
            GetTagInfo.GenreStr = "Bebop"
        Case 96
            GetTagInfo.GenreStr = "Big Band"
        Case 138
            GetTagInfo.GenreStr = "Black Metal"
        Case 89
            GetTagInfo.GenreStr = "Bluegrass"
        Case 0
            GetTagInfo.GenreStr = "Blues"
        Case 107
            GetTagInfo.GenreStr = "Booty Bass"
        Case 132
            GetTagInfo.GenreStr = "BritPop"
        Case 65
            GetTagInfo.GenreStr = "Cabaret"
        Case 88
            GetTagInfo.GenreStr = "Celtic"
        Case 104
            GetTagInfo.GenreStr = "Chamber Music"
        Case 102
            GetTagInfo.GenreStr = "Chanson"
        Case 97
            GetTagInfo.GenreStr = "Chorus"
        Case 136
            GetTagInfo.GenreStr = "Christian Gangsta Rap"
        Case 61
            GetTagInfo.GenreStr = "Christian Rap"
        Case 141
            GetTagInfo.GenreStr = "Christian Rock"
        Case 1
            GetTagInfo.GenreStr = "Classic Rock"
        Case 32
            GetTagInfo.GenreStr = "Classical"
        Case 112
            GetTagInfo.GenreStr = "Club"
        Case 128
            GetTagInfo.GenreStr = "Club-House"
        Case 57
            GetTagInfo.GenreStr = "Comedy"
        Case 140
            GetTagInfo.GenreStr = "Contemporary Christian"
        Case 2
            GetTagInfo.GenreStr = "Country"
        Case 139
            GetTagInfo.GenreStr = "Crossover"
        Case 58
            GetTagInfo.GenreStr = "Cult"
        Case 3
            GetTagInfo.GenreStr = "Dance"
        Case 125
            GetTagInfo.GenreStr = "Dance Hall"
        Case 50
            GetTagInfo.GenreStr = "Darkwave"
        Case 22
            GetTagInfo.GenreStr = "Death Metal"
        Case 4
            GetTagInfo.GenreStr = "Disco"
        Case 55
            GetTagInfo.GenreStr = "Dream"
        Case 127
            GetTagInfo.GenreStr = "Drum & Bass"
        Case 122
            GetTagInfo.GenreStr = "Drum Solo"
        Case 120
            GetTagInfo.GenreStr = "Duet"
        Case 98
            GetTagInfo.GenreStr = "Easy Listening"
        Case 52
            GetTagInfo.GenreStr = "Electronic"
        Case 48
            GetTagInfo.GenreStr = "Ethnic"
        Case 54
            GetTagInfo.GenreStr = "Eurodance"
        Case 124
            GetTagInfo.GenreStr = "Euro-House"
        Case 25
            GetTagInfo.GenreStr = "Euro-Techno"
        Case 84
            GetTagInfo.GenreStr = "Fast-Fusion"
        Case 80
            GetTagInfo.GenreStr = "Folk"
        Case 81
            GetTagInfo.GenreStr = "Folk/Rock"
        Case 115
            GetTagInfo.GenreStr = "Folklore"
        Case 119
            GetTagInfo.GenreStr = "Freestyle"
        Case 5
            GetTagInfo.GenreStr = "Funk"
        Case 30
            GetTagInfo.GenreStr = "Fusion"
        Case 36
            GetTagInfo.GenreStr = "Game"
        Case 59
            GetTagInfo.GenreStr = "Gangsta Rap"
        Case 126
            GetTagInfo.GenreStr = "Goa"
        Case 38
            GetTagInfo.GenreStr = "Gospel"
        Case 49
            GetTagInfo.GenreStr = "Gothic"
        Case 91
            GetTagInfo.GenreStr = "Gothic Rock"
        Case 6
            GetTagInfo.GenreStr = "Grunge"
        Case 79
            GetTagInfo.GenreStr = "Hard Rock"
        Case 129
            GetTagInfo.GenreStr = "Hardcore"
        Case 137
            GetTagInfo.GenreStr = "Heavy Metal"
        Case 7
            GetTagInfo.GenreStr = "Hip-Hop"
        Case 35
            GetTagInfo.GenreStr = "House"
        Case 100
            GetTagInfo.GenreStr = "Humor"
        Case 131
            GetTagInfo.GenreStr = "Indie"
        Case 19
            GetTagInfo.GenreStr = "Industrial"
        Case 33
            GetTagInfo.GenreStr = "Instrumental"
        Case 46
            GetTagInfo.GenreStr = "Instrumental Pop"
        Case 47
            GetTagInfo.GenreStr = "Instrumental Rock"
        Case 8
            GetTagInfo.GenreStr = "Jazz"
        Case 29
            GetTagInfo.GenreStr = "Jazz+Funk"
        Case 146
            GetTagInfo.GenreStr = "JPop"
        Case 63
            GetTagInfo.GenreStr = "Jungle"
        Case 86
            GetTagInfo.GenreStr = "Latin"
        Case 71
            GetTagInfo.GenreStr = "Lo-Fi"
        Case 45
            GetTagInfo.GenreStr = "Meditative"
        Case 142
            GetTagInfo.GenreStr = "Merengue"
        Case 9
            GetTagInfo.GenreStr = "Metal"
        Case 77
            GetTagInfo.GenreStr = "Musical"
        Case 82
            GetTagInfo.GenreStr = "National Folk"
        Case 64
            GetTagInfo.GenreStr = "Native American"
        Case 133
            GetTagInfo.GenreStr = "Negerpunk"
        Case 10
            GetTagInfo.GenreStr = "New Age"
        Case 66
            GetTagInfo.GenreStr = "New Wave"
        Case 39
            GetTagInfo.GenreStr = "Noise"
        Case 11
            GetTagInfo.GenreStr = "Oldies"
        Case 103
            GetTagInfo.GenreStr = "Opera"
        Case 12
            GetTagInfo.GenreStr = "Other"
        Case 75
            GetTagInfo.GenreStr = "Polka"
        Case 134
            GetTagInfo.GenreStr = "Polsk Punk"
        Case 13
            GetTagInfo.GenreStr = "Pop"
        Case 62
            GetTagInfo.GenreStr = "Pop/Funk"
        Case 53
            GetTagInfo.GenreStr = "Pop-Folk"
        Case 109
            GetTagInfo.GenreStr = "Porn Groove"
        Case 117
            GetTagInfo.GenreStr = "Power Ballad"
        Case 23
            GetTagInfo.GenreStr = "Pranks"
        Case 108
            GetTagInfo.GenreStr = "Primus"
        Case 92
            GetTagInfo.GenreStr = "Progressive Rock"
        Case 67
            GetTagInfo.GenreStr = "Psychedelic"
        Case 93
            GetTagInfo.GenreStr = "Psychedelic Rock"
        Case 43
            GetTagInfo.GenreStr = "Punk"
        Case 121
            GetTagInfo.GenreStr = "Punk Rock"
        Case 14
            GetTagInfo.GenreStr = "R&B"
        Case 15
            GetTagInfo.GenreStr = "Rap"
        Case 68
            GetTagInfo.GenreStr = "Rave"
        Case 16
            GetTagInfo.GenreStr = "Reggae"
        Case 76
            GetTagInfo.GenreStr = "Retro"
        Case 87
            GetTagInfo.GenreStr = "Revival"
        Case 118
            GetTagInfo.GenreStr = "Rhythmic Soul"
        Case 17
            GetTagInfo.GenreStr = "Rock"
        Case 78
            GetTagInfo.GenreStr = "Rock & Roll"
        Case 143
            GetTagInfo.GenreStr = "Salsa"
        Case 114
            GetTagInfo.GenreStr = "Samba"
        Case 110
            GetTagInfo.GenreStr = "Satire"
        Case 69
            GetTagInfo.GenreStr = "Showtunes"
        Case 21
            GetTagInfo.GenreStr = "Ska"
        Case 111
            GetTagInfo.GenreStr = "Slow Jam"
        Case 95
            GetTagInfo.GenreStr = "Slow Rock"
        Case 105
            GetTagInfo.GenreStr = "Sonata"
        Case 42
            GetTagInfo.GenreStr = "Soul"
        Case 37
            GetTagInfo.GenreStr = "Sound Clip"
        Case 24
            GetTagInfo.GenreStr = "Soundtrack"
        Case 56
            GetTagInfo.GenreStr = "Southern Rock"
        Case 44
            GetTagInfo.GenreStr = "Space"
        Case 101
            GetTagInfo.GenreStr = "Speech"
        Case 83
            GetTagInfo.GenreStr = "Swing"
        Case 94
            GetTagInfo.GenreStr = "Symphonic Rock"
        Case 106
            GetTagInfo.GenreStr = "Symphony"
        Case 147
            GetTagInfo.GenreStr = "Synthpop"
        Case 113
            GetTagInfo.GenreStr = "Tango"
        Case 18
            GetTagInfo.GenreStr = "Techno"
        Case 51
            GetTagInfo.GenreStr = "Techno-Industrial"
        Case 130
            GetTagInfo.GenreStr = "Terror"
        Case 144
            GetTagInfo.GenreStr = "Thrash Metal"
        Case 60
            GetTagInfo.GenreStr = "Top 40"
        Case 70
            GetTagInfo.GenreStr = "Trailer"
        Case 31
            GetTagInfo.GenreStr = "Trance"
        Case 72
            GetTagInfo.GenreStr = "Tribal"
        Case 27
            GetTagInfo.GenreStr = "Trip-Hop"
        Case 28
            GetTagInfo.GenreStr = "Vocal"
    End Select
End With
End Function

Private Function TrimExcess(strinput As String) As String
For a = Len(strinput) To 1 Step -1
    If Asc(Mid$(strinput, a, 1)) > 32 Then
        TrimExcess = Left$(strinput, a)
        Exit Function
    End If
Next a
TrimExcess = strinput
End Function

